## Installation

Build cpp extensions via
```bash 
cd ./sparse-lora
pip install .
```


## Usage

Run the scripts placed in scripts/llm_pretrain/. Typical usage:

```bash
# LLaMA-60M, SpLora-Adam, 1 A100, 1 Node
torchrun --standalone --nproc_per_node 1 torchrun_main.py \
    --model_config configs/llama_60m.json \
    --lr 0.005 \
    --peft_model splora \
    --optimizer adamw \
    --rank 128 \ 
    --sp_ratio 0.03 \ 
    --batch_size 256 \
    --total_batch_size 512 \
    --num_training_steps 10000 \
    --warmup_steps 1000 \
    --weight_decay 0 \
    --dtype bfloat16 \
    --eval_every 1000 \
    --lora_alpha 16 \
```


